<template>
  <section id="user-list">
    <div id="user-list-filters">
      <input type="text" class="username-search" v-model="usernameSearch"
      name="username-search" placeholder="search user names">
      <span>
        <label>
          <input type="checkbox" name="user-gender-male" value="male" checked v-model="showMales">
          Male
        </label>
        <label>
          <input type="checkbox" name="user-gender-female" value="female" checked v-model="showFemales">
          Female
        </label>
      </span>
    </div>
    <div id="user-list-scroll">
      <div v-if="users.length">
        <UserListEntry v-for="user in filteredUsers" :user="user"/>
        <button type="button" id="more-results-button" name="more-results-button"
        v-on:click="fetchMoreUsers()">
          More results...
        </button>
      </div>
    </div>
  </section>
</template>

<script lang="ts">
import { defineComponent } from 'vue';
import store from '../store';
import UserListEntry from './UserListEntry.vue';
import { User } from '../types/User';
import { Gender } from '../types/Gender';

export default defineComponent({
  computed: {
    filteredUsers(): User[] {
      localStorage.setItem("usernameSearch", this.usernameSearch);
      localStorage.setItem("showMales",      this.showMales.toString());
      localStorage.setItem("showFemales",    this.showFemales.toString());
      return (this.users as User[]).filter(user => {
        return (
                 (this.showMales   && user.gender == Gender.male  ) ||
                 (this.showFemales && user.gender == Gender.female)
               )
               &&
               (user.name.first + ' ' + user.name.last).toUpperCase()
                   .includes(this.usernameSearch.trim().toUpperCase());
      });
    },
  },
  props: {
    users: Array,
  },
  data: () => {
    return {
      usernameSearch: '' as string,
      showMales: true as Boolean,
      showFemales: true as Boolean,
    }
  },
  components: {
    UserListEntry,
  },
  methods: {
    fetchMoreUsers() {
      store.dispatch('fetchUsers', { count: 25 });
    },
  },
  created() {
    this.usernameSearch = (localStorage.getItem("usernameSearch") ?? ''  );
    this.showMales      = (localStorage.getItem("showMales")   != 'false');
    this.showFemales    = (localStorage.getItem("showFemales") != 'false');
  },
  mounted() {
    document.getElementById('user-list-scroll')?.addEventListener('scroll', (event) => {
      let scrollTop    = (event.target as any)?.scrollTop;
      let scrollHeight = (event.target as any)?.scrollHeight;
      let offsetHeight = (event.target as any)?.offsetHeight;
      if ((scrollHeight - offsetHeight) <= scrollTop) {
        store.dispatch('fetchUsers', { count: 25 });
      }
    });
  },
});
</script>

<style lang="scss">
#user-list {
  flex: 30%;
  min-width: 400px;
  display: flex;
  flex-direction: column;
  background: #20222d;
  #user-list-filters {
    box-shadow: 0 5px 5px #0003;
    .username-search {
      background: #0003;
      border: none;
      padding: 10px;
      width: calc(100% - 20px);
      margin: 10px;
      box-sizing: border-box;
      outline: none;
    }
    label {
      margin: 10px;
      display: inline-block;
    }
  }
  #user-list-scroll {
    overflow-y: auto;
    #more-results-button {
      display: block;
      background: #ffffff0d;
      border: none;
      border-radius: 5px;
      width: calc(100% - 20px);
      margin: 10px;
      padding: 20px;
      cursor: pointer;
      &:hover {
        background: #ffffff26;
      }
    }
  }
}
</style>
